(function(name,definition) {
    if( typeof define == "function" && typeof define.amd == "object" ) {
        define( name, [ "underscore" ], definition );
    } else if ( typeof module === "object" && module.exports ) {
        module.exports = definition( require( "underscore" ) );
    } else {
        this[name] = definition( _ );
    }
}("underscore-ext", function( _ ) {

    function mapV( obj, fn ) {
        return _.chain( obj )
            .map( function(v,k) { return [ k, fn(v,k) ]; } )
            .object()
            .value();
    }

    function mapK( obj, fn ) {
        return _.chain( obj )
            .map( function(v,k) { return [ fn(v,k), v ]; } )
            .object()
            .value();
    }

    function mapVK( obj, fn ) {
        return _.chain( obj )
            .map( fn )
            .object()
            .value();
    }

    function filterVK( obj, fn ) {
        return _.chain( obj )
            .pairs()
            .filter( function(x) { return fn( x[1], x[0] ); } )
            .object()
            .value();
    }

    _.mixin({
        mapK : mapK,
        mapV : mapV,
        mapVK : mapVK,
        filterVK : filterVK
    });

    return _;
    
}));
